﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ConvertTextFileGUI
{
    internal class EncInfoItem
    {

        readonly string displayName;

        readonly string ianaName;

        readonly string name;

        readonly int codePage;

        readonly bool isEmpty = false;

        public string DisplayName
        {
            get { return this.displayName; }
        }

        public string IanaName
        {
            get { return this.ianaName; }
        }

        public string Name
        {
            get { return this.name; }
        }

        public int CodePage
        {
            get { return this.codePage; }
        }

        public bool IsEmpty
        {
            get { return this.isEmpty; }
        }


        public EncInfoItem( EncodingInfo enc)
        {
            if( enc == null )
            {
                throw new ArgumentNullException();
            }

            this.ianaName = enc.Name;
            this.name = enc.DisplayName;
            this.codePage = enc.CodePage;
            this.displayName = this.name + " (" + this.ianaName + ", " + enc.CodePage.ToString() + ")";
        }

        public EncInfoItem( Encoding enc )
        {
            if( enc == null )
            {
                throw new ArgumentNullException();
            }

            this.ianaName = enc.WebName;
            this.name = enc.EncodingName;
            this.codePage = enc.CodePage;
            this.displayName = this.name + " (" + this.ianaName + ", " + enc.CodePage.ToString() + ")";
        }

        public EncInfoItem( Encoding enc, string displayName )
        {
            if( displayName == null )
            {
                throw new ArgumentException( "displayName" );
            }

            if( enc == null )
            {
                this.ianaName = null;
                this.name = null;
                this.codePage = 0;
                this.isEmpty = true;
                this.displayName = displayName;
            }
            else
            {
                this.ianaName = enc.WebName;
                this.name = enc.EncodingName;
                this.codePage = enc.CodePage;
                this.displayName = displayName;
            }

        }


        public override string ToString()
        {
            return this.DisplayName;
        }

    }
}
